<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en"><head>

<meta charset="utf-8">
<meta name="generator" content="quarto-1.4.549">

<meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes">


<title>r8</title>
<style>
code{white-space: pre-wrap;}
span.smallcaps{font-variant: small-caps;}
div.columns{display: flex; gap: min(4vw, 1.5em);}
div.column{flex: auto; overflow-x: auto;}
div.hanging-indent{margin-left: 1.5em; text-indent: -1.5em;}
ul.task-list{list-style: none;}
ul.task-list li input[type="checkbox"] {
  width: 0.8em;
  margin: 0 0.8em 0.2em -1em; /* quarto-specific, see https://github.com/quarto-dev/quarto-cli/issues/4556 */ 
  vertical-align: middle;
}
/* CSS for citations */
div.csl-bib-body { }
div.csl-entry {
  clear: both;
  margin-bottom: 0em;
}
.hanging-indent div.csl-entry {
  margin-left:2em;
  text-indent:-2em;
}
div.csl-left-margin {
  min-width:2em;
  float:left;
}
div.csl-right-inline {
  margin-left:2em;
  padding-left:1em;
}
div.csl-indent {
  margin-left: 2em;
}</style>


<script src="r8_files/libs/clipboard/clipboard.min.js"></script>
<script src="r8_files/libs/quarto-html/quarto.js"></script>
<script src="r8_files/libs/quarto-html/popper.min.js"></script>
<script src="r8_files/libs/quarto-html/tippy.umd.min.js"></script>
<script src="r8_files/libs/quarto-html/anchor.min.js"></script>
<link href="r8_files/libs/quarto-html/tippy.css" rel="stylesheet">
<link href="r8_files/libs/quarto-html/quarto-syntax-highlighting.css" rel="stylesheet" id="quarto-text-highlighting-styles">
<script src="r8_files/libs/bootstrap/bootstrap.min.js"></script>
<link href="r8_files/libs/bootstrap/bootstrap-icons.css" rel="stylesheet">
<link href="r8_files/libs/bootstrap/bootstrap.min.css" rel="stylesheet" id="quarto-bootstrap" data-mode="light">

  <script src="https://polyfill.io/v3/polyfill.min.js?features=es6"></script>
  <script src="https://cdn.jsdelivr.net/npm/mathjax@3/es5/tex-chtml-full.js" type="text/javascript"></script>

<script type="text/javascript">
const typesetMath = (el) => {
  if (window.MathJax) {
    // MathJax Typeset
    window.MathJax.typeset([el]);
  } else if (window.katex) {
    // KaTeX Render
    var mathElements = el.getElementsByClassName("math");
    var macros = [];
    for (var i = 0; i < mathElements.length; i++) {
      var texText = mathElements[i].firstChild;
      if (mathElements[i].tagName == "SPAN") {
        window.katex.render(texText.data, mathElements[i], {
          displayMode: mathElements[i].classList.contains('display'),
          throwOnError: false,
          macros: macros,
          fleqn: false
        });
      }
    }
  }
}
window.Quarto = {
  typesetMath
};
</script>

</head>

<body class="fullcontent">

<div id="quarto-content" class="page-columns page-rows-contents page-layout-article">

<main class="content" id="quarto-document-content">




<div class="cell">
<style type="text/css">
.justify {
  text-align: justify !important
}
</style>
</div>
<section id="rekomendowane-metody-pomiaru-utraty-informacji-w-wyniku-ukrycia-przekrojów-objętych-tajemnicą-statystyczną" class="level1">
<h1>Rekomendowane metody pomiaru utraty informacji w&nbsp;wyniku ukrycia przekrojów objętych tajemnicą statystyczną</h1>
<section id="dane-zagregowane" class="level2">
<h2 class="anchored" data-anchor-id="dane-zagregowane">Dane zagregowane</h2>
<div class="justify">
<p>W przypadku danych zagregowanych ocena straty informacji na skutek zastosowania kontroli ujawniania danych dokonywana jest – najogólniej rzecz ujmując – poprzez porównanie odpowiednich danych otrzymanych na podstawie informacji oryginalnych z odpowiednimi wielkościami po zastosowaniu metod SDC. W przypadku, gdy stosowane są metody niezakłóceniowe, miary tego rodzaju bazują głównie na liczbie komórek ukrytych lub zakresie stosowanych kategorii przed i po SDC. Özsoyoğlu i Chung <span class="citation" data-cites="ozsoyoglu1986information">(<a href="#ref-ozsoyoglu1986information" role="doc-biblioref">1986</a>)</span> zasugerowali, dla przykładu, miarę straty informacji dla tablicy chronionej poprzez ukrywanie komórek jako odsetek komórek z ukrytymi wartościami. Jest to najprostsze rozwiązanie, które można powszechnie stosować. Oczywiście ma ono pewne wady. Po pierwsze, komórki, które zostały ukryte mogą mieć niewielkie liczebności, nie wpływające nazbyt istotnie na zasób przekazywanych informacji. Po drugie nie wskazuje na faktyczną skalę różnic między danymi przed i po zastosowaniu SDC wynikających ze statystycznej specyfiki owych danych. Dlatego też np. de Waal i Willenborg <span class="citation" data-cites="de1998optimal">(<a href="#ref-de1998optimal" role="doc-biblioref">1998</a>)</span> rozważali wiele innych możliwości w tym zakresie (np. ukrywanie specyficznych zmiennych dla specyficznych rekordów) poprzez możliwie najefektywniejsze skoncentrowanie się na owych ukryciach lub na liczbie kategorii, na które te ukrycia wpływają.</p>
<p>W tym właśnie duchu Hundepool i in. <span class="citation" data-cites="hundepool2012statistical">(<a href="#ref-hundepool2012statistical" role="doc-biblioref">2012</a>)</span> proponują oprzeć pomiar straty informacji na liczbie lub sumie wartości komórek podlegających ukrywaniu wtórnemu. Ten drugi wariant wydaje się lepszy. <strong>Proponuje się zatem zastosować w tym kontekście – ewentualnie znormalizowaną podzieleniem przez wartość oryginalną dla zachowania porównywalności – sumę bezwzględnych różnic między wartościami komórek przed i po SDC</strong>, przy czym jako „zastępczą” wartość dla ukrytej komórki można przyjąć wynikającą ze specyfiki tablicy i cechy najmniejszą wartość jaka mogłaby się tam znaleźć. Pozwala to zminimalizować możliwość niedoszacowania straty informacji. Shlomo i Young <span class="citation" data-cites="shlomo2006information">(<a href="#ref-shlomo2006information" role="doc-biblioref">2006</a>)</span> proponują z kolei wyznaczanie straty na bazie odchylenia sumy częstości dla komórek nieukrytych od oryginalnych częstości brzegowych (z ewentualnym ważeniem, gdy występują wagi).</p>
<p>W przypadku zastosowania metod zakłóceniowych sytuacja wydaje się być nieco łatwiejsza z rozpatrywanego punktu widzenia. Tutaj – podążając także za opinią Hundepoola i in. <span class="citation" data-cites="hundepool2012statistical">(<a href="#ref-hundepool2012statistical" role="doc-biblioref">2012</a>)</span> – <strong>strata informacji powinna być mierzona globalnie za pomocą statystyki opisowej rozkładu odchylenia wartości zniekształconych od prawdziwych ocenianego przy pomocy odpowiedniej funkcji (np. wartości bezwzględnej różnicy pomiędzy odpowiednimi wartościami czy takiej różnicy podzielonej przez wartość oryginalną lub liczebność komórki)</strong>. Statystyka ta może być np. średnią arytmetyczną, medianą lub innym kwantylem, wartością maksymalną, itp., albo też – jak proponują np. Shlomo i Young <span class="citation" data-cites="shlomo2006information">(<a href="#ref-shlomo2006information" role="doc-biblioref">2006</a>)</span> – odległością Hellingera, relatywnym odchyleniem bezwzględnym czy przeciętnym odchyleniem bezwzględnym. Pewien problem, jaki z tym się wiąże, polega na tym, że użytkownik otrzymując jeden kompleksowy miernik może nabrać wątpliwości co do jakości wszystkich komórek. Jednak zaopatrzenie przekazywanego mu wyniku w stosowne objaśnienia powinno temu zapobiec.</p>
<p>Opisane wyżej sposoby pomiaru straty informacji można zrealizować w praktyce używając środowiska R. Pewne miary (oparte na różnicy między wartościami oryginalnymi i zakłóconymi) wbudowano do pakietu cellKey. Ważne jest przy tym, aby wybrany sposób stosować jednolicie dla całego badania.</p>
<p>Do danych zagregowanych należą też oszacowania wielkości dla populacji otrzymane na podstawie danych zgromadzonych w badaniu reprezentacyjnym z wykorzystaniem odpowiednich wag. W przypadku wprowadzenia zakłóceń problem straty informacji wydaje się bardziej złożony i wymagający odrębnych studiów. Obecnie można w tym kontekście zaproponować jedynie oparcie oceny straty informacji na porównaniach wartości współczynnika zmienności estymatora (podstawowego miernika jakości oszacowania) dla szacunku opartego na danych oryginalnych i na danych zakłóconych czy sugestie Shlomo i Young <span class="citation" data-cites="shlomo2006information">(<a href="#ref-shlomo2006information" role="doc-biblioref">2006</a>)</span> w&nbsp;zakresie oceny wpływu zakłóceń na wariancję szacunków, dotyczące oceny tego wpływu poprzez wyznaczenie względnej różnicy między wariancją dla agregatu uzyskaną na postawie danych oryginalnych a&nbsp;stosowną wariancją opartą na danych poddanych kontroli ujawniania.</p>
<section id="dane-jednostkowe" class="level2">
<h2 class="anchored" data-anchor-id="dane-jednostkowe">Dane jednostkowe</h2>
<p>Jak dotąd kwestii pomiaru straty informacji na skutek kontroli ujawniania danych poświęcono stosunkowo niewiele miejsca i czasu. Zagadnienia te rozpatrywane są tylko w kontekście oceny efektywności metod SDC, a&nbsp;nie przydatności samych mierników. Ponadto warto przypomnieć, że problemem w tym względzie jest też – podobnie jak w przypadku ryzyka – różnorodność skal pomiarowych, na których wyrażane są wartości poszczególnych zmiennych. Domingo–Ferrer, Mateo–Sanz i Torra <span class="citation" data-cites="domingo2001comparing">(<a href="#ref-domingo2001comparing" role="doc-biblioref">2001</a>)</span> rozważają zatem <strong>kilka podejść w tym zakresie dla zmiennych ciągłych (uśrednione lub zrelatywizowane bezwzględne różnice – albo kwadraty różnic – między wartościami oryginalnymi a zniekształconymi czy też – w kontekście straty na zróżnicowaniu i&nbsp;korelacji – podobne funkcje dla różnic między stosownymi wskaźnikami) i osobno rozwiązania dla zmiennych kategorialnych</strong>. Mogą one dać pewien obraz sytuacji, jednak wyniki ich zastosowania są dość trudno interpretowalne i porównywalne. Dlatego Młodak A. <span class="citation" data-cites="mlodak2019wykorzystanie mlodak2020strata">(<a href="#ref-mlodak2019wykorzystanie" role="doc-biblioref">2019</a>, <a href="#ref-mlodak2020strata" role="doc-biblioref">2020</a>)</span> zaproponował <strong>uniwersalne miary straty informacji dla całego zbioru, z uwzględnieniem wszystkich skal pomiarowych</strong>. Miary te mają postać znormalizowaną na <span class="math inline">\([0;1]\)</span>, co znacznie ułatwia ich interpretację (użytkownik otrzymuje kompleksową informację o szacowanej stracie w %). Można je stosować praktycznie bez ograniczeń, trzeba wszakże odpowiednio uwzględnić braki danych. Zaleca się czynić to w taki sposób, aby możliwie w największy sposób wyeksponować odpowiednie różnice pomiędzy wartościami prawdziwymi a „zastępczymi” (to znaczy jeżeli zmienna wyrażona jest na skali nominalnej wówczas jako odległość między wartością oryginalną a brakiem danych przyjmuje się 1; gdy jest to skala porządkowa wtedy jeżeli oryginalna wartość zmiennej jest bliższa maksymalnej jej kategorii, wówczas „zastępczo” brakowi danych przyporządkowuje się najniższą kategorię tejże zmiennej, w przeciwnym razie – gdy oryginalna kategoria okazuje się bliższa kategorii najmniejszej – brak danych uznaje się za kategorię największą; w przypadku zmiennej ciągłej zaś jeżeli oryginalna wartość jest nie większa od mediany, wtedy kładziemy dla ukrytej oryginalne maksimum wartości, w przeciwnym razie – minimum). Pozwala to zminimalizować możliwość niedoszacowania straty informacji. Miary te znalazły zastosowanie m.in. w pracy metodologicznej z zakresu kontroli ujawniania danych w badaniu wypadków przy pracy (zob. Młodak, Pietrzak i&nbsp;Józefowski <span class="citation" data-cites="mlodak2022trade">(<a href="#ref-mlodak2022trade" role="doc-biblioref">2022</a>)</span>). Szczegółowy ich opis wraz z odpowiednią egzemplifikacją można też znaleźć w książce Młodaka i in. <span class="citation" data-cites="mlodak2023poufnosc">(<a href="#ref-mlodak2023poufnosc" role="doc-biblioref">2023</a>)</span>.</p>
<p>Ubogie w narzędzia oceny straty informacji są także dostępne narzędzia komputerowe z zakresu kontroli ujawniania danych. I tak, program <span class="math inline">\(\mu–Argus\)</span> oblicza w zasadzie w tym kontekście jedynie liczbę ukryć lokalnych (a zatem ogranicza się tylko do metod niezakłóceniowych). Z kolei pakiet sdcMicro środowiska R daje możliwość wyznaczania dwóch miar straty: <strong>IL1 (średniej zestandaryzowanych odchyleniem standardowym danej zmiennej wartości bezwzględnych różnic między obserwacjami przed i po SDC) i wskaźnika opartego na różnicach między wartościami własnymi macierzy korelacji</strong> (Templ, Kowarik i Meindl <span class="citation" data-cites="templ2015statistical">(<a href="#ref-templ2015statistical" role="doc-biblioref">2015</a>)</span>). Ponieważ miara IL1 jest wysoce wrażliwa na niewielkie zakłócenia oraz słabe zróżnicowanie wartości cech, zaś miernik bazujący na wartościach własnych ma problemy w przypadku występowania braków danych, zatem należy stosować je z&nbsp;dużą ostrożnością. Oprócz tego konstrukcja pakietu sdcMicro powoduje, że nie zawsze możliwe jest przechowanie wszystkich modyfikacji w zbiorze spowodowanych SDC (zwłaszcza gdy korzysta się z innych pakietów lub konieczna jest zmiana formatu danych przy pewnych czynnościach). Do tego pakietu zaimplementowano również rozwiązania zaproponowane przez Młodaka <span class="citation" data-cites="mlodak2020strata">(<a href="#ref-mlodak2020strata" role="doc-biblioref">2020</a>)</span> – czyli miary zakłócenia rozkładu opartej na koncepcji odległości Gowera z wykorzystaniem funkcji cyklometrycznej (a dokładniej arcus tangens) oraz miary straty na korelacji zmiennych ciągłych bazującej na elementach diagonalnych odwróconej macierzy korelacji przed i po SDC (w wersji z korektą opisaną w pracy Młodaka, Pietrzaka i Józefowskiego <span class="citation" data-cites="mlodak2022trade">(<a href="#ref-mlodak2022trade" role="doc-biblioref">2022</a>)</span>). Wyznacza się tutaj macierz korelacji zmiennych, a następnie znajduje się macierz do niej odwrotną i&nbsp;bierze pod uwagę jej wartości na przekątnej. Stosowanie tych miar daje nadzieję na to, że wiele z opisanych wyżej problemów może zostać zniwelowanych, a zestaw powszechnie rekomendowanych rozwiązań stanie się szerszy.</p>
<p>Podsumowując, konieczne jest wyznaczenie straty informacji na skutek przeprowadzonej kontroli ujawniania danych w zakresie zakłócenia rozkładu w ujęciu globalnym oraz straty na poszczególnych zmiennych (co umożliwia wspomniana wyżej miara zakłócenia rozkładu zaproponowana przez Młodaka <span class="citation" data-cites="mlodak2020strata">(<a href="#ref-mlodak2020strata" role="doc-biblioref">2020</a>)</span>), jak również w&nbsp;kontekście wpływu zaburzeń ochronnych na siłę związku między poszczególnymi zmiennymi ciągłymi.</p>
<p>Na zakończenie należy zauważyć, że ocena straty informacji może być przeprowadzona w następujących fazach schematu GSBPM (MPPS):</p>
<ul>
<li><strong><em>Projektowanie</em></strong></li>
<li><strong><em>Przetwarzanie i analiza</em></strong></li>
<li><strong><em>Ocena</em></strong>.</li>
</ul>
<p>Ocena straty informacji może być dokonywana wyłącznie poprzez porównanie danych przed i po zaburzeniu. Chcąc uzyskać pełny i rzetelny szacunek tej straty należy zatem zachować zbiór danych oryginalnych i&nbsp;wygenerować w analogicznym formacie i zakresie zmiennych zbiór po realizacji działań zmierzających do zapewnienia należytej ochrony tajemnicy statystycznej.</p>
<p>Zgodnie z <em>Polityką postępowania z danymi statystycznymi</em> zaleca się, aby wybór metody bądź metod kontroli ujawniania danych był poprzedzony oceną ryzyka ujawnienia informacji chronionych, objętych tajemnicą statystyczną, z jednoczesną oceną ponoszonej straty informacji.</p>
</section>
</div>
</section>
</section>
<section id="bibliography" class="level1 unnumbered">


</section>

<div id="quarto-appendix" class="default"><section class="quarto-appendix-contents" role="doc-bibliography" id="quarto-bibliography"><h2 class="anchored quarto-appendix-heading">Bibliografia</h2><div id="refs" class="references csl-bib-body hanging-indent" data-entry-spacing="0" data-line-spacing="2" role="list">
<div id="ref-de1998optimal" class="csl-entry" role="listitem">
De Waal, A., &amp; Willenborg, L. C. (1998). Optimal local suppression in microdata. <em>Journal of Official Statistics</em>, <em>14</em>(4), 421. <a href="https://scholar.google.it/scholar?oi=bibs&amp;cluster=9220555753877121103&amp;btnI=1&amp;hl=it)">https://scholar.google.it/scholar?oi=bibs&amp;cluster=9220555753877121103&amp;btnI=1&amp;hl=it)</a>
</div>
<div id="ref-domingo2001comparing" class="csl-entry" role="listitem">
Domingo-Ferrer, J., Mateo-Sanz, J. M., &amp; Torra, V. (2001). Comparing SDC methods for microdata on the basis of information loss and disclosure risk. <em>Pre-Proceedings of ETK-NTTS</em>, <em>2</em>, 807–826.
</div>
<div id="ref-hundepool2012statistical" class="csl-entry" role="listitem">
Hundepool, A., Domingo-Ferrer, J., Franconi, L., Giessing, S., Nordholt, E. S., Spicer, K., &amp; De Wolf, P.-P. (2012). <em>Statistical disclosure control</em>. John Wiley &amp; Sons.
</div>
<div id="ref-mlodak2019wykorzystanie" class="csl-entry" role="listitem">
Młodak, A. (2019). Wykorzystanie miernika kompleksowego w ocenie straty informacji na skutek kontroli ujawniania mikrodanych. <em>Przegl<span>ą</span>d Statystyczny</em>, <em>66</em>(1), 7–26.
</div>
<div id="ref-mlodak2020strata" class="csl-entry" role="listitem">
Młodak, A. (2020). Strata informacji wskutek przeprowadzenia kontroli ujawniania danych wynikowych. <em>Wiadomo<span>ś</span>ci Statystyczne. The Polish Statistician</em>, <em>65</em>(09), 7–27.
</div>
<div id="ref-mlodak2022trade" class="csl-entry" role="listitem">
Młodak, A., Pietrzak, M., &amp; Józefowski, T. (2022). The trade-off between the risk of disclosure and data utility in SDC: A case of data from a survey of accidents at work 1. <em>Statistical Journal of the IAOS</em>, <em>38</em>(4), 1503–1511.
</div>
<div id="ref-mlodak2023poufnosc" class="csl-entry" role="listitem">
Młodak, A., Pietrzak, M., Klimanek, T., Józefowski, T., &amp; Lańduch, P. (2023). <em>Poufno<span>ś</span><span>ć</span> a u<span>ż</span>yteczno<span>ś</span><span>ć</span> informacji statystycznych. Dylematy ochrony udost<span>ę</span>pnianych danych</em>. Wydawnictwo Uniwersytetu Ekonomicznego w Poznaniu.
</div>
<div id="ref-ozsoyoglu1986information" class="csl-entry" role="listitem">
Ozsoyoglu, G., &amp; Chung, J. (1986). Information loss in the lattice model of summary tables due to cell suppression. <em>1986 IEEE Second International Conference on Data Engineering</em>, 75–83.
</div>
<div id="ref-shlomo2006information" class="csl-entry" role="listitem">
Shlomo, N., &amp; Young, C. (2006). Information loss measures for frequency tables. <em>Monographs of Official Statistics – Work Session on Statistical Data Confidentiality, Geneva, 9–11 November 2005</em>, 277–289. <a href="https://ec.europa.eu/eurostat/documents/3217494/5652105/KS-CR-03-004-1-EN.PDF.pdf/81a84bca-0189-4c94-a690-73923623d210?t=1414771516000">https://ec.europa.eu/eurostat/documents/3217494/5652105/KS-CR-03-004-1-EN.PDF.pdf/81a84bca-0189-4c94-a690-73923623d210?t=1414771516000</a>
</div>
<div id="ref-templ2015statistical" class="csl-entry" role="listitem">
Templ, M., Kowarik, A., &amp; Meindl, B. (2015). Statistical disclosure control for micro-data using the r package sdcMicro. <em>Journal of Statistical Software</em>, <em>67</em>, 1–36.
</div>
</div></section></div></main>
<!-- /main column -->
<script id="quarto-html-after-body" type="application/javascript">
window.document.addEventListener("DOMContentLoaded", function (event) {
  const toggleBodyColorMode = (bsSheetEl) => {
    const mode = bsSheetEl.getAttribute("data-mode");
    const bodyEl = window.document.querySelector("body");
    if (mode === "dark") {
      bodyEl.classList.add("quarto-dark");
      bodyEl.classList.remove("quarto-light");
    } else {
      bodyEl.classList.add("quarto-light");
      bodyEl.classList.remove("quarto-dark");
    }
  }
  const toggleBodyColorPrimary = () => {
    const bsSheetEl = window.document.querySelector("link#quarto-bootstrap");
    if (bsSheetEl) {
      toggleBodyColorMode(bsSheetEl);
    }
  }
  toggleBodyColorPrimary();  
  const icon = "";
  const anchorJS = new window.AnchorJS();
  anchorJS.options = {
    placement: 'right',
    icon: icon
  };
  anchorJS.add('.anchored');
  const isCodeAnnotation = (el) => {
    for (const clz of el.classList) {
      if (clz.startsWith('code-annotation-')) {                     
        return true;
      }
    }
    return false;
  }
  const clipboard = new window.ClipboardJS('.code-copy-button', {
    text: function(trigger) {
      const codeEl = trigger.previousElementSibling.cloneNode(true);
      for (const childEl of codeEl.children) {
        if (isCodeAnnotation(childEl)) {
          childEl.remove();
        }
      }
      return codeEl.innerText;
    }
  });
  clipboard.on('success', function(e) {
    // button target
    const button = e.trigger;
    // don't keep focus
    button.blur();
    // flash "checked"
    button.classList.add('code-copy-button-checked');
    var currentTitle = button.getAttribute("title");
    button.setAttribute("title", "Copied!");
    let tooltip;
    if (window.bootstrap) {
      button.setAttribute("data-bs-toggle", "tooltip");
      button.setAttribute("data-bs-placement", "left");
      button.setAttribute("data-bs-title", "Copied!");
      tooltip = new bootstrap.Tooltip(button, 
        { trigger: "manual", 
          customClass: "code-copy-button-tooltip",
          offset: [0, -8]});
      tooltip.show();    
    }
    setTimeout(function() {
      if (tooltip) {
        tooltip.hide();
        button.removeAttribute("data-bs-title");
        button.removeAttribute("data-bs-toggle");
        button.removeAttribute("data-bs-placement");
      }
      button.setAttribute("title", currentTitle);
      button.classList.remove('code-copy-button-checked');
    }, 1000);
    // clear code selection
    e.clearSelection();
  });
  function tippyHover(el, contentFn, onTriggerFn, onUntriggerFn) {
    const config = {
      allowHTML: true,
      maxWidth: 500,
      delay: 100,
      arrow: false,
      appendTo: function(el) {
          return el.parentElement;
      },
      interactive: true,
      interactiveBorder: 10,
      theme: 'quarto',
      placement: 'bottom-start',
    };
    if (contentFn) {
      config.content = contentFn;
    }
    if (onTriggerFn) {
      config.onTrigger = onTriggerFn;
    }
    if (onUntriggerFn) {
      config.onUntrigger = onUntriggerFn;
    }
    window.tippy(el, config); 
  }
  const noterefs = window.document.querySelectorAll('a[role="doc-noteref"]');
  for (var i=0; i<noterefs.length; i++) {
    const ref = noterefs[i];
    tippyHover(ref, function() {
      // use id or data attribute instead here
      let href = ref.getAttribute('data-footnote-href') || ref.getAttribute('href');
      try { href = new URL(href).hash; } catch {}
      const id = href.replace(/^#\/?/, "");
      const note = window.document.getElementById(id);
      return note.innerHTML;
    });
  }
  const xrefs = window.document.querySelectorAll('a.quarto-xref');
  const processXRef = (id, note) => {
    // Strip column container classes
    const stripColumnClz = (el) => {
      el.classList.remove("page-full", "page-columns");
      if (el.children) {
        for (const child of el.children) {
          stripColumnClz(child);
        }
      }
    }
    stripColumnClz(note)
    if (id === null || id.startsWith('sec-')) {
      // Special case sections, only their first couple elements
      const container = document.createElement("div");
      if (note.children && note.children.length > 2) {
        container.appendChild(note.children[0].cloneNode(true));
        for (let i = 1; i < note.children.length; i++) {
          const child = note.children[i];
          if (child.tagName === "P" && child.innerText === "") {
            continue;
          } else {
            container.appendChild(child.cloneNode(true));
            break;
          }
        }
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(container);
        }
        return container.innerHTML
      } else {
        if (window.Quarto?.typesetMath) {
          window.Quarto.typesetMath(note);
        }
        return note.innerHTML;
      }
    } else {
      // Remove any anchor links if they are present
      const anchorLink = note.querySelector('a.anchorjs-link');
      if (anchorLink) {
        anchorLink.remove();
      }
      if (window.Quarto?.typesetMath) {
        window.Quarto.typesetMath(note);
      }
      // TODO in 1.5, we should make sure this works without a callout special case
      if (note.classList.contains("callout")) {
        return note.outerHTML;
      } else {
        return note.innerHTML;
      }
    }
  }
  for (var i=0; i<xrefs.length; i++) {
    const xref = xrefs[i];
    tippyHover(xref, undefined, function(instance) {
      instance.disable();
      let url = xref.getAttribute('href');
      let hash = undefined; 
      if (url.startsWith('#')) {
        hash = url;
      } else {
        try { hash = new URL(url).hash; } catch {}
      }
      if (hash) {
        const id = hash.replace(/^#\/?/, "");
        const note = window.document.getElementById(id);
        if (note !== null) {
          try {
            const html = processXRef(id, note.cloneNode(true));
            instance.setContent(html);
          } finally {
            instance.enable();
            instance.show();
          }
        } else {
          // See if we can fetch this
          fetch(url.split('#')[0])
          .then(res => res.text())
          .then(html => {
            const parser = new DOMParser();
            const htmlDoc = parser.parseFromString(html, "text/html");
            const note = htmlDoc.getElementById(id);
            if (note !== null) {
              const html = processXRef(id, note);
              instance.setContent(html);
            } 
          }).finally(() => {
            instance.enable();
            instance.show();
          });
        }
      } else {
        // See if we can fetch a full url (with no hash to target)
        // This is a special case and we should probably do some content thinning / targeting
        fetch(url)
        .then(res => res.text())
        .then(html => {
          const parser = new DOMParser();
          const htmlDoc = parser.parseFromString(html, "text/html");
          const note = htmlDoc.querySelector('main.content');
          if (note !== null) {
            // This should only happen for chapter cross references
            // (since there is no id in the URL)
            // remove the first header
            if (note.children.length > 0 && note.children[0].tagName === "HEADER") {
              note.children[0].remove();
            }
            const html = processXRef(null, note);
            instance.setContent(html);
          } 
        }).finally(() => {
          instance.enable();
          instance.show();
        });
      }
    }, function(instance) {
    });
  }
      let selectedAnnoteEl;
      const selectorForAnnotation = ( cell, annotation) => {
        let cellAttr = 'data-code-cell="' + cell + '"';
        let lineAttr = 'data-code-annotation="' +  annotation + '"';
        const selector = 'span[' + cellAttr + '][' + lineAttr + ']';
        return selector;
      }
      const selectCodeLines = (annoteEl) => {
        const doc = window.document;
        const targetCell = annoteEl.getAttribute("data-target-cell");
        const targetAnnotation = annoteEl.getAttribute("data-target-annotation");
        const annoteSpan = window.document.querySelector(selectorForAnnotation(targetCell, targetAnnotation));
        const lines = annoteSpan.getAttribute("data-code-lines").split(",");
        const lineIds = lines.map((line) => {
          return targetCell + "-" + line;
        })
        let top = null;
        let height = null;
        let parent = null;
        if (lineIds.length > 0) {
            //compute the position of the single el (top and bottom and make a div)
            const el = window.document.getElementById(lineIds[0]);
            top = el.offsetTop;
            height = el.offsetHeight;
            parent = el.parentElement.parentElement;
          if (lineIds.length > 1) {
            const lastEl = window.document.getElementById(lineIds[lineIds.length - 1]);
            const bottom = lastEl.offsetTop + lastEl.offsetHeight;
            height = bottom - top;
          }
          if (top !== null && height !== null && parent !== null) {
            // cook up a div (if necessary) and position it 
            let div = window.document.getElementById("code-annotation-line-highlight");
            if (div === null) {
              div = window.document.createElement("div");
              div.setAttribute("id", "code-annotation-line-highlight");
              div.style.position = 'absolute';
              parent.appendChild(div);
            }
            div.style.top = top - 2 + "px";
            div.style.height = height + 4 + "px";
            div.style.left = 0;
            let gutterDiv = window.document.getElementById("code-annotation-line-highlight-gutter");
            if (gutterDiv === null) {
              gutterDiv = window.document.createElement("div");
              gutterDiv.setAttribute("id", "code-annotation-line-highlight-gutter");
              gutterDiv.style.position = 'absolute';
              const codeCell = window.document.getElementById(targetCell);
              const gutter = codeCell.querySelector('.code-annotation-gutter');
              gutter.appendChild(gutterDiv);
            }
            gutterDiv.style.top = top - 2 + "px";
            gutterDiv.style.height = height + 4 + "px";
          }
          selectedAnnoteEl = annoteEl;
        }
      };
      const unselectCodeLines = () => {
        const elementsIds = ["code-annotation-line-highlight", "code-annotation-line-highlight-gutter"];
        elementsIds.forEach((elId) => {
          const div = window.document.getElementById(elId);
          if (div) {
            div.remove();
          }
        });
        selectedAnnoteEl = undefined;
      };
        // Handle positioning of the toggle
    window.addEventListener(
      "resize",
      throttle(() => {
        elRect = undefined;
        if (selectedAnnoteEl) {
          selectCodeLines(selectedAnnoteEl);
        }
      }, 10)
    );
    function throttle(fn, ms) {
    let throttle = false;
    let timer;
      return (...args) => {
        if(!throttle) { // first call gets through
            fn.apply(this, args);
            throttle = true;
        } else { // all the others get throttled
            if(timer) clearTimeout(timer); // cancel #2
            timer = setTimeout(() => {
              fn.apply(this, args);
              timer = throttle = false;
            }, ms);
        }
      };
    }
      // Attach click handler to the DT
      const annoteDls = window.document.querySelectorAll('dt[data-target-cell]');
      for (const annoteDlNode of annoteDls) {
        annoteDlNode.addEventListener('click', (event) => {
          const clickedEl = event.target;
          if (clickedEl !== selectedAnnoteEl) {
            unselectCodeLines();
            const activeEl = window.document.querySelector('dt[data-target-cell].code-annotation-active');
            if (activeEl) {
              activeEl.classList.remove('code-annotation-active');
            }
            selectCodeLines(clickedEl);
            clickedEl.classList.add('code-annotation-active');
          } else {
            // Unselect the line
            unselectCodeLines();
            clickedEl.classList.remove('code-annotation-active');
          }
        });
      }
  const findCites = (el) => {
    const parentEl = el.parentElement;
    if (parentEl) {
      const cites = parentEl.dataset.cites;
      if (cites) {
        return {
          el,
          cites: cites.split(' ')
        };
      } else {
        return findCites(el.parentElement)
      }
    } else {
      return undefined;
    }
  };
  var bibliorefs = window.document.querySelectorAll('a[role="doc-biblioref"]');
  for (var i=0; i<bibliorefs.length; i++) {
    const ref = bibliorefs[i];
    const citeInfo = findCites(ref);
    if (citeInfo) {
      tippyHover(citeInfo.el, function() {
        var popup = window.document.createElement('div');
        citeInfo.cites.forEach(function(cite) {
          var citeDiv = window.document.createElement('div');
          citeDiv.classList.add('hanging-indent');
          citeDiv.classList.add('csl-entry');
          var biblioDiv = window.document.getElementById('ref-' + cite);
          if (biblioDiv) {
            citeDiv.innerHTML = biblioDiv.innerHTML;
          }
          popup.appendChild(citeDiv);
        });
        return popup.innerHTML;
      });
    }
  }
});
</script>
</div> <!-- /content -->




</body></html>